﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ContSys
{
    class FileLogger
    {
        StateMachine sm;
        String path = @"C:\ControlSystemData\CS_log.txt";
        String dir = @"C:\ControlSystemData";
        List<string> datas = new List<string>();

        public FileLogger(StateMachine sm)
        {
            this.sm = sm;
            initLogFile();

            //just testing
            /*
            for (int i = 0 ;i < 900000; i++)  //ca. 90000 sek/tag-->900000 logs/tag (10/sek)
            {
                log();
            }
            log();
            log();
            logLine("Line");
            log();
            log();
            log();
            emptyCache();*/
        }

        public void log()
        {
            String data = DateTime.Now.ToString("d/M/yyyy HH:mm:ss.fff");
            data += "\tTEMPERATURE_SENSOR1:\t" + sm.TEMPERATURE_SENSOR1;
            data += "\tTEMPERATURE_SENSOR2:\t" + sm.TEMPERATURE_SENSOR2;
            data += "\tTEMPERATURE_SENSOR3:\t" + sm.TEMPERATURE_SENSOR3;
            data += "\tTEMPERATURE_SENSOR4:\t" + sm.TEMPERATURE_SENSOR4;
            data += "\tTEMPERATURE_SENSOR5:\t" + sm.TEMPERATURE_SENSOR5;
            data += "\tPRESSURE_SENSOR1:\t" + sm.PRESSURE_SENSOR1;
            data += "\tPRESSURE_SENSOR2:\t" + sm.PRESSURE_SENSOR2;
            data += "\tCOMPRESSOR_STATUS:\t" + sm.COMPRESSOR_STATUS;
            data += "\tCOOLING_STATUS:\t" + sm.COOLING_STATUS;


            datas.Add(data);

            if(datas.Count == 5)
            {
                checkLogFile();

                using (System.IO.StreamWriter file = new System.IO.StreamWriter(path, true))
                {
                    foreach(string line in datas.ToArray())
                    {
                        file.WriteLine(line); //nimmt nur string
                    }
                    datas.Clear();
                }
            }

        }

        public void lognow()
        {
            //empty logcache
            emptyCache();

            String data = DateTime.Now.ToString("d/M/yyyy HH:mm:ss.fff");

            data += "\tTEMPERATURE_SENSOR1:\t" + sm.TEMPERATURE_SENSOR1;
            data += "\tTEMPERATURE_SENSOR2:\t" + sm.TEMPERATURE_SENSOR2;
            data += "\tTEMPERATURE_SENSOR3:\t" + sm.TEMPERATURE_SENSOR3;
            data += "\tTEMPERATURE_SENSOR4:\t" + sm.TEMPERATURE_SENSOR4;
            data += "\tTEMPERATURE_SENSOR5:\t" + sm.TEMPERATURE_SENSOR5;
            data += "\tPRESSURE_SENSOR1:\t" + sm.PRESSURE_SENSOR1;
            data += "\tPRESSURE_SENSOR2:\t" + sm.PRESSURE_SENSOR2;
            data += "\tCOMPRESSOR_STATUS:\t" + sm.COMPRESSOR_STATUS;
            data += "\tCOOLING_STATUS:\t" + sm.COOLING_STATUS;


            using (System.IO.StreamWriter file = new System.IO.StreamWriter(path, true))
                {
                        file.WriteLine(data); //nimmt nur string
                }

        }
        public void logLine(String line)
        {
            //empty logcache
            emptyCache();

            using (System.IO.StreamWriter file = new System.IO.StreamWriter(path, true))
            {
                file.WriteLine(line); //nimmt nur string
            }
        }


        public void emptyCache()
        {
            using (System.IO.StreamWriter file = new System.IO.StreamWriter(path, true))
            {
                foreach (string line in datas.ToArray())
                {
                    file.WriteLine(line); //nimmt nur string
                }
                datas.Clear();
            }
        }

        void initLogFile()
        {
            if (!System.IO.Directory.Exists(dir))
            {
                System.IO.Directory.CreateDirectory(dir);
            }
            if (!System.IO.File.Exists(path))
            {
                System.IO.File.Create(path);
            }
        }

        void checkLogFile()
        {
            if (!System.IO.File.Exists(path))
            {
                initLogFile();
            }
        }
    }
}
