﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ContSys
{
    public partial class Overview : Form
    {

        BPC bpc_window;
        LC lc_window;
        TGS tgs_window;
        IPC ipc_window;
        FS fs_window;
        StateMachine sm;
        

        public Overview(StateMachine sm)
        {
            InitializeComponent();

            this.sm = sm;

            bpc_window = new BPC(sm);
            lc_window = new LC(sm);
            tgs_window = new TGS(sm);
            ipc_window = new IPC(sm);
            fs_window = new FS(sm);
        }

        private void button_showW1_click(object sender, EventArgs e)
        {
            bpc_window.Show();
            bpc_window.BringToFront();
        }

        private void button_showW2_Click(object sender, EventArgs e)
        {
            lc_window.Show();
            lc_window.BringToFront();
        }

        private void button_showW3_Click(object sender, EventArgs e)
        {
            tgs_window.Show();
            tgs_window.BringToFront();
        }

        private void button_showW4_Click(object sender, EventArgs e)
        {
            ipc_window.Show();
            ipc_window.BringToFront();
        }

        private void button_showFS_Click(object sender, EventArgs e)
        {
            fs_window.Show();
            fs_window.BringToFront();
        }

        private void Overview_Load(object sender, EventArgs e)
        {
            refreshTimer.Start();
        }

        private void refreshTimer_Tick(object sender, EventArgs e)
        {
            //bpc
            if (sm.bpc_Current_condenser_valve_opening == true)
                bpc_current_condenser_valve_opening_textBox.Text = "Open";
            else 
                bpc_current_condenser_valve_opening_textBox.Text = "Close";

            tools.setupBackColor(sm.bpc_Current_condenser_valve_opening,bpc_current_condenser_valve_opening_textBox);

            if (sm.bpc_Current_atmospheric_valve_opening == true)
                bpc_current_atmospheric_valve_opening_textBox.Text = "Open";
            else 
                bpc_current_atmospheric_valve_opening_textBox.Text = "Close";
            tools.setupBackColor(sm.bpc_Current_atmospheric_valve_opening, bpc_current_atmospheric_valve_opening_textBox);


            bpc_current_pressure_textBox.Text = sm.bpc_Current_pressure.ToString();
            condenser_current_pressure_textBox.Text = sm.Condenser_current_pressure.ToString();
            //tgs
            tgs_current_turbine_speed_textBox.Text = sm.tgs_Current_turbine_speed.ToString();
            tgs_current_valve_opening_textBox.Text = sm.tgs_Current_valve_opening.ToString();
            //ipc
            exhaustfan1_textBox.Text = sm.Current_exhaustfan1_status.ToString();
            tools.setupBackColor(sm.Current_exhaustfan1_status, exhaustfan1_textBox);
            exhaustfan2_textBox.Text = sm.Current_exhaustfan2_status.ToString();
            tools.setupBackColor(sm.Current_exhaustfan2_status, exhaustfan2_textBox);

            textBox1.Text = sm.Current_exhaustfan3_status.ToString();
            tools.setupBackColor(sm.Current_exhaustfan3_status, textBox1);

            textBox2.Text = sm.Current_fuelburner1_status.ToString();
            tools.setupBackColor(sm.Current_fuelburner1_status, textBox2);

            lc_wasterpump1phase_textBox.Text = sm.lc_Current_waterpump1phase_status.ToString();
            tools.setupBackColor(sm.lc_Current_waterpump1phase_status, lc_wasterpump1phase_textBox);
            ipc_supplyfan_textBox.Text = sm.ipc_Current_supplyfan_status.ToString();
            tools.setupBackColor(sm.ipc_Current_supplyfan_status, ipc_supplyfan_textBox);
            //lc

            //other
            coolingpump_textBox.Text = sm.Current_coolingpump_status.ToString();
            tools.setupBackColor(sm.Current_coolingpump_status, coolingpump_textBox);

            //not yet(just test)
            current_test_status_textBox.Text = sm.Current_test_status.ToString();
            current_number_test_status_textBox.Text = sm.Current_number_test_status.ToString();
        }

        private void current_valve_opening_textBox_TextChanged(object sender, EventArgs e)
        {

        }



        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {

        }

        private void coolingpump_button_Click(object sender, EventArgs e)
        {
            if (coolingpump_button.Text == "CMD OFF")
            {
                sm.setOnOffCoolingPump(true);
                //coolingpump_status_label.Text = "ON CMD SENDET";
                //tools.setupBackColor(true, coolingpump_status_label);
                coolingpump_button.Text = "CMD ON";
                tools.setupBackColor(true, coolingpump_button);
            }
            else
            {
                sm.setOnOffCoolingPump(false);
                //coolingpump_status_label.Text = "OFF CMD SENDET";
                //tools.setupBackColor(false, coolingpump_status_label);
                coolingpump_button.Text = "CMD OFF";
                tools.setupBackColor(false, coolingpump_button);
            }
        }



        private void exhaustfan2_button_Click(object sender, EventArgs e)
        {
            if (exhaustfan2_button.Text == "CMD OFF")
            {
                sm.inceneratorPowerControl_setOnOffExhaustfan2(true);
                //exhaustfan2_status_label.Text = "ON CMD SENDET";
                //tools.setupBackColor(true, exhaustfan2_status_label);
                exhaustfan2_button.Text = "CMD ON";
                tools.setupBackColor(true, exhaustfan2_button);
            }
            else
            {
                sm.inceneratorPowerControl_setOnOffExhaustfan2(false);
                //exhaustfan2_status_label.Text = "OFF CMD SENDET";
                //tools.setupBackColor(false, exhaustfan2_status_label);
                exhaustfan2_button.Text = "CMD OFF";
                tools.setupBackColor(false, exhaustfan2_button);
            }
        }

        private void exhaustfan1_button_Click(object sender, EventArgs e)
        {
            if (exhaustfan1_button.Text == "CMD OFF")
            {
                sm.inceneratorPowerControl_setOnOffExhaustfan1(true);
                //exhaustfan1_status_label.Text = "ON CMD SENDET";
                //tools.setupBackColor(true, exhaustfan1_status_label);
                exhaustfan1_button.Text = "CMD ON";
                tools.setupBackColor(true, exhaustfan1_button);
            }
            else
            {
                sm.inceneratorPowerControl_setOnOffExhaustfan1(false);
                //exhaustfan1_status_label.Text = "OFF CMD SENDET";
                //tools.setupBackColor(false, exhaustfan1_status_label);
                exhaustfan1_button.Text = "CMD OFF";
                tools.setupBackColor(false, exhaustfan1_button);
            }
        }

        private void ipc_supplyfan_button_Click(object sender, EventArgs e)
        {
            if (ipc_supplyfan_button.Text == "CMD OFF")
            {
                sm.inceneratorPowerControl_setOnOffSupplyfan(true);
                //ipc_supplyfan_status_label.Text = "ON CMD SENDET";
                //tools.setupBackColor(true,ipc_supplyfan_status_label);
                ipc_supplyfan_button.Text = "CMD ON";
                tools.setupBackColor(true, ipc_supplyfan_button);
            }
            else
            {
                sm.inceneratorPowerControl_setOnOffSupplyfan(false);
                //ipc_supplyfan_status_label.Text = "OFF CMD SENDET";
                //tools.setupBackColor(false, ipc_supplyfan_status_label);
                ipc_supplyfan_button.Text = "CMD OFF";
                tools.setupBackColor(false, ipc_supplyfan_button);
            }
        }

        private void label9_Click(object sender, EventArgs e)
        {

        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (button1.Text == "CMD OFF")
            {
                sm.inceneratorPowerControl_setOnOffExhaustfan3(true);
                //exhaustfan2_status_label.Text = "ON CMD SENDET";
                //tools.setupBackColor(true, exhaustfan2_status_label);
                button1.Text = "CMD ON";
                tools.setupBackColor(true, button1);
            }
            else
            {
                sm.inceneratorPowerControl_setOnOffExhaustfan3(false);
                //exhaustfan2_status_label.Text = "OFF CMD SENDET";
                //tools.setupBackColor(false, exhaustfan2_status_label);
                button1.Text = "CMD OFF";
                tools.setupBackColor(false, button1);
            }

        }

        private void button2_Click(object sender, EventArgs e)
        {

        }

        private void fuelburner1_button_Click(object sender, EventArgs e)
        {
            if (fuelburner1_button.Text == "CMD OFF")
            {
                sm.inceneratorPowerControl_setOnOffFuelBurner1(true);
                //fuelburner1_status_label.Text = "ON CMD SENDET";

                fuelburner1_button.Text = "CMD ON";
                tools.setupBackColor(true, fuelburner1_button);
            }
            else
            {
                sm.inceneratorPowerControl_setOnOffFuelBurner1(false);
                //fuelburner1_status_label.Text = "OFF CMD SENDET";

                fuelburner1_button.Text = "CMD OFF";
                tools.setupBackColor(false, fuelburner1_button);
            }

           
        }

        private void label17_Click(object sender, EventArgs e)
        {

        }

        private void label16_Click(object sender, EventArgs e)
        {

        }

        private void textBox3_TextChanged(object sender, EventArgs e)
        {

        }

        private void button2_Click_1(object sender, EventArgs e)
        {


        }

        private void Condenser_Pump_Button_Click(object sender, EventArgs e)
        {
            if (Condenser_Pump_Button.Text == "Gene power")
            {
                sm.boilerPressureControl_condense_Pump(true);


                Condenser_Pump_Button.Text = "Ipp power";
                tools.setupBackColor(true, Condenser_Pump_Button);
            }
            else
            {
                sm.boilerPressureControl_condense_Pump(false);

                Condenser_Pump_Button.Text = "Gene power";
                tools.setupBackColor(false, Condenser_Pump_Button);
            }
         

        }

        private void lc_waterpump1phase_button_Click(object sender, EventArgs e)
        {
            if (lc_waterpump1phase_button.Text == "CMD OFF")
            {
                sm.lc_setOnOffWaterPump1Phase(true);
                //ipc_wastemotor_status_label.Text = "ON CMD SENDET";
                //tools.setupBackColor(true, ipc_wastemotor_status_label);
                lc_waterpump1phase_button.Text = "CMD ON";
                tools.setupBackColor(true, lc_waterpump1phase_button);
            }
            else
            {
                sm.lc_setOnOffWaterPump1Phase(false);
                //ipc_wastemotor_status_label.Text = "OFF CMD SENDET";
                //tools.setupBackColor(false, ipc_wastemotor_status_label);
                lc_waterpump1phase_button.Text = "CMD OFF";
                tools.setupBackColor(false, lc_waterpump1phase_button);
            }

        }

        private void textBox3_TextChanged_1(object sender, EventArgs e)
        {

        }

        private void bpc_current_pressure_textBox_TextChanged(object sender, EventArgs e)
        {

        }
    }
}
